#ifndef __WAVEGENERATORBCIMPL_H__
#define __WAVEGENERATORBCIMPL_H__

#include <UserModules/UserBoundaryCondition.h>
#include <cmath>

class CWaveGeneratorBC
{
public:

   CWaveGeneratorBC();
   ~CWaveGeneratorBC();

   void SetInitParams(INTEROP_COUNT _numParameters, const FVDLL_PARAMETER* _pParameters);
   void InitParameterContext(FVAPI_VARIABLE _hVariable, INTEROP_STRING _idParam, FVDLL_CONTEXT* _outParameterContext);
   void GetValueInContext(FVDLL_PARAMETER_CONTEXT _hParameterContext, FVAPI_CONTEXT _hVarContext, INTEROP_DOUBLE* _outValue);

   INTEROP_DOUBLE GetVOFInContext(FVAPI_CONTEXT _hVarContext);
   void GetVelocityFixedInContext(FVAPI_CONTEXT _hVarContext, INTEROP_DOUBLE* _outValue);

protected:

   // Auxiliary result check function
   static void CheckRes(INTEROP_RESULT _res) { if (_res != INTEROP_OK) throw _res; }
   INTEROP_DOUBLE DotProd(INTEROP_DOUBLE* _a, INTEROP_DOUBLE* _b);

   INTEROP_DOUBLE m_Period;              // Wave period
   INTEROP_DOUBLE m_High;                // Wave high
   INTEROP_DOUBLE m_Direction[3];        // Wave direction
   INTEROP_DOUBLE m_RefPoint[3];         // Reference point
   INTEROP_DOUBLE m_ConstVel[3];         // Constant velocity
};

#endif // __WAVEGENERATORBCIMPL_H__
