#ifndef __INTEROP_TYPES_H__
#define __INTEROP_TYPES_H__

#include <stdint.h>

#ifdef INTEROP_INT8
#undef INTEROP_INT8
#endif
#ifdef INTEROP_UINT8
#undef INTEROP_UINT8
#endif
#ifdef INTEROP_INT16
#undef INTEROP_INT16
#endif
#ifdef INTEROP_UINT16
#undef INTEROP_UINT16
#endif
#ifdef INTEROP_INT32
#undef INTEROP_INT32
#endif
#ifdef INTEROP_UINT32
#undef INTEROP_UINT32
#endif
#ifdef INTEROP_INT64
#undef INTEROP_INT64
#endif
#ifdef INTEROP_UINT64
#undef INTEROP_UINT64
#endif

typedef int8_t      INTEROP_INT8;     ///<  8- 
typedef uint8_t     INTEROP_UINT8;    ///<  8- 
typedef int16_t     INTEROP_INT16;    ///<  16- 
typedef uint16_t    INTEROP_UINT16;   ///<  16- 
typedef int32_t     INTEROP_INT32;    ///<  32- 
typedef uint32_t    INTEROP_UINT32;   ///<  32- 
typedef int64_t     INTEROP_INT64;    ///<  64- 
typedef uint64_t    INTEROP_UINT64;   ///<  64- 

#ifdef INTEROP_BYTE
#undef INTEROP_BYTE
#endif
typedef INTEROP_UINT8 INTEROP_BYTE;    ///<  

#ifdef INTEROP_INDEX
#undef INTEROP_INDEX
#endif
typedef INTEROP_UINT32 INTEROP_INDEX;  ///< 32-  

#ifdef INTEROP_COUNT
#undef INTEROP_COUNT
#endif
typedef INTEROP_UINT32 INTEROP_COUNT;  ///< 32-  

#ifdef INTEROP_OFFSET
#undef INTEROP_OFFSET
#endif
typedef INTEROP_INT32 INTEROP_OFFSET;  ///< 32-  

#ifdef INTEROP_LARGE
#undef INTEROP_LARGE
#endif
typedef INTEROP_INT64 INTEROP_LARGE;   ///< 64-  ,   

#ifdef INTEROP_BOOL
#undef INTEROP_BOOL
#endif
typedef INTEROP_UINT8 INTEROP_BOOL;    ///<  ,  

#ifdef INTEROP_FALSE
#undef INTEROP_FALSE
#endif
#ifdef INTEROP_TRUE
#undef INTEROP_TRUE
#endif

/// @brief   
typedef enum ENUM_INTEROP_BOOL {
   INTEROP_FALSE, ///<  ""
   INTEROP_TRUE   ///<  ""
} ENUM_INTEROP_BOOL;

#ifdef INTEROP_RESULT
#undef INTEROP_RESULT
#endif
typedef INTEROP_UINT32 INTEROP_RESULT; ///<  ,  32-  

#ifdef INTEROP_ENUM
#undef INTEROP_ENUM
#endif
typedef INTEROP_INT32 INTEROP_ENUM;    ///<  ,  32-  

#ifdef INTEROP_POINTER
#undef INTEROP_POINTER
#endif
typedef void* INTEROP_POINTER;         ///<  

#ifdef INTEROP_HANDLE
#undef INTEROP_HANDLE
#endif
typedef void* INTEROP_HANDLE;          ///<  

#ifdef INTEROP_DOUBLE
#undef INTEROP_DOUBLE
#endif
typedef double INTEROP_DOUBLE;         ///<    

#ifdef INTEROP_STRING
#undef INTEROP_STRING
#endif
typedef char* INTEROP_STRING;          ///<     UTF-8

#endif // ifndef __INTEROP_TYPES_H__
